My Project: dgKinematicBody Class Reference

My Project

Public Member Functions | Static Public Attributes | Friends | List of all members
dgKinematicBody Class Reference

`#include <dgKinematicBody.h>`

Inheritance diagram for dgKinematicBody:

## Public Member Functions

| dgKinematicBody ()
| dgKinematicBody (dgWorld *const world, const dgTree< const dgCollision *, dgInt32 > *const collisionNode, dgDeserialize serializeCallback, void *const userData)
virtual | ~dgKinematicBody ()
virtual const dgVector & | GetForce () const
virtual const dgVector & | GetTorque () const
virtual void | AddForce (const dgVector &force)
virtual void | AddTorque (const dgVector &torque)
virtual void | SetForce (const dgVector &force)
virtual void | SetTorque (const dgVector &torque)
virtual void | ApplyExtenalForces (dgFloat32 timestep, dgInt32 threadIndex)
virtual OnApplyExtForceAndTorque | GetExtForceAndTorqueCallback () const
virtual void | SetExtForceAndTorqueCallback (OnApplyExtForceAndTorque callback)
virtual dgFloat32 | GetLinearDamping () const
virtual dgVector | GetAngularDamping () const
virtual void | SetLinearDamping (dgFloat32 linearDamp)
virtual void | SetAngularDamping (const dgVector &angularDamp)
virtual dgVector | PredictLinearVelocity (dgFloat32 timestep) const
virtual dgVector | PredictAngularVelocity (dgFloat32 timestep) const
virtual bool | IsInEquilibrium () const
virtual void | SetCollidable (bool state)
virtual void | Serialize (const dgTree< dgInt32, const dgCollision *> *const collisionNode, dgSerialize serializeCallback, void *const userData)
virtual void | AddDampingAcceleration ()
Public Member Functions inherited from dgBody
| dgBody ()
| dgBody (dgWorld *const world, const dgTree< const dgCollision *, dgInt32 > *const collisionNode, dgDeserialize serializeCallback, void *const userData)
virtual | ~dgBody ()
dgType | GetType () const
dgInt32 | IsRTTIType (dgUnsigned32 rtti) const
void * | GetUserData () const
void | SetUserData (void *const userData)
dgWorld * | GetWorld () const
const dgMatrix & | GetMatrix () const
const dgQuaternion & | GetRotation () const
const dgVector & | GetPosition () const
void | SetCentreOfMass (const dgVector &com)
const dgVector & | GetCentreOfMass () const
void | GetAABB (dgVector &p0, dgVector &p1) const
const dgVector & | GetOmega () const
const dgVector & | GetVelocity () const
const dgVector & | GetNetForce () const
const dgVector & | GetNetTorque () const
dgVector | GetVelocityAtPoint (const dgVector &point) const
void | SetOmega (const dgVector &omega)
void | SetVelocity (const dgVector &velocity)
dgUnsigned32 | GetGroupID () const
virtual void | SetGroupID (dgUnsigned32 id)
dgInt32 | GetUniqueID () const
bool | GetContinueCollisionMode () const
void | SetContinueCollisionMode (bool mode)
bool | GetCollisionWithLinkedBodies () const
void | SetCollisionWithLinkedBodies (bool state)
void | Freeze ()
void | Unfreeze ()
bool | GetFreeze () const
void | SetFreeze (bool state)
bool | GetSleepState () const
void | SetSleepState (bool state)
bool | GetAutoSleep () const
void | SetAutoSleep (bool state)
dgCollisionInstance * | GetCollision () const
dgBodyMasterList::dgListNode * | GetMasterList () const
OnBodyDestroy | GetDestructorCallback () const
void | SetDestructorCallback (OnBodyDestroy destructor)
OnMatrixUpdateCallback | GetMatrixUpdateCallback () const
void | SetMatrixUpdateCallback (OnMatrixUpdateCallback callback)
dgVector | GetMass () const
dgVector | GetInvMass () const
const dgMatrix & | GetInertiaMatrix () const
virtual dgMatrix | CalculateInertiaMatrix () const
virtual dgMatrix | CalculateInvInertiaMatrix () const
bool | IsCollidable () const
virtual void | SetMassMatrix (dgFloat32 mass, dgFloat32 Ix, dgFloat32 Iy, dgFloat32 Iz)
virtual void | SetMassProperties (dgFloat32 mass, const dgCollisionInstance *const collision)
virtual void | AddImpulse (const dgVector &pointVeloc, const dgVector &pointPosit)
virtual void | ApplyImpulsePair (const dgVector &linearImpulse, const dgVector &angularImpulse)
virtual void | ApplyImpulsesAtPoint (dgInt32 count, dgInt32 strideInBytes, const dgFloat32 *const impulseArray, const dgFloat32 *const pointArray)
virtual void | InvalidateCache ()
virtual void | SetMatrix (const dgMatrix &matrix)
virtual void | SetMatrixIgnoreSleep (const dgMatrix &matrix)
virtual void | IntegrateVelocity (dgFloat32 timestep)
virtual void | AttachCollision (dgCollisionInstance *const collision)
virtual dgFloat32 | RayCast (const dgLineBox &line, OnRayCastAction filter, OnRayPrecastAction preFilter, void *const userData, dgFloat32 minT) const
virtual dgFloat32 | ConvexRayCast (const dgFastRayTest &ray, const dgCollisionInstance *const convexShape, const dgVector &shapeMinBox, const dgVector &shapeMaxBox, const dgMatrix &origin, const dgVector &shapeVeloc, OnRayCastAction filter, OnRayPrecastAction preFilter, void *const userData, dgFloat32 minT, dgInt32 threadId) const
virtual dgConstraint * | GetFirstJoint () const
virtual dgConstraint * | GetNextJoint (dgConstraint *const joint) const
virtual dgConstraint * | GetFirstContact () const
virtual dgConstraint * | GetNextContact (dgConstraint *const joint) const
virtual dgVector | CalculateInverseDynamicForce (const dgVector &desiredVeloc, dgFloat32 timestep) const
void | SetMatrixOriginAndRotation (const dgMatrix &matrix)

## Static Public Attributes

static dgVector | m_dummy

## Friends

class | dgWorld
class | dgWorldDynamicUpdate
class | dgBroadPhase

## Additional Inherited Members

Public Types inherited from dgBody
enum | dgRTTI { m_baseBodyRTTI = 1<<0, m_dynamicBodyRTTI = 1<<1, m_kinematicBodyRTTI = 1<<2, m_deformableBodyRTTI = 1<<3 }
enum | dgType { m_dynamicBody = 0, m_kinematicBody, m_deformableBody }
typedef void(dgApi * | OnBodyDestroy) (dgBody &me)
typedef void(dgApi * | OnApplyExtForceAndTorque) (dgBody &me, dgFloat32 timestep, dgInt32 threadIndex)
typedef void(dgApi * | OnMatrixUpdateCallback) (const dgBody &me, const dgMatrix &matrix, dgInt32 threadIndex)
Protected Member Functions inherited from dgBody
void | UpdateWorlCollisionMatrix () const
void | UpdateMatrix (dgFloat32 timestep, dgInt32 threadIndex)
void | UpdateCollisionMatrix (dgFloat32 timestep, dgInt32 threadIndex)
void | CalcInvInertiaMatrix ()
dgVector | GetApparentMass () const
void | SetAparentMassMatrix (const dgVector &massMatrix)
Protected Attributes inherited from dgBody
dgMatrix | m_invWorldInertiaMatrix
dgMatrix | m_matrix
dgQuaternion | m_rotation
dgVector | m_mass
dgVector | m_invMass
dgVector | m_veloc
dgVector | m_omega
dgVector | m_minAABB
dgVector | m_maxAABB
dgVector | m_netForce
dgVector | m_netTorque
dgVector | m_localCentreOfMass
dgVector | m_globalCentreOfMass
dgVector | m_aparentMass
dgInt32 | m_index
dgInt32 | m_uniqueID
dgInt32 | m_bodyGroupId
dgInt32 | m_rtti
dgInt32 | m_type
dgUnsigned32 | m_dynamicsLru
dgUnsigned32 | m_genericLRUMark
dgThread::dgCriticalSection | m_criticalSectionLock
union {
dgUnsigned32 m_flags
struct {
dgUnsigned32 m_freeze: 1
dgUnsigned32 m_sleeping: 1
dgUnsigned32 m_autoSleep: 1
dgUnsigned32 m_equilibrium: 1
dgUnsigned32 m_continueCollisionMode: 1
dgUnsigned32 m_spawnnedFromCallback: 1
dgUnsigned32 m_collideWithLinkedBodies: 1
dgUnsigned32 m_inCallback: 1
dgUnsigned32 m_collidable: 1
dgUnsigned32 m_resting: 1
dgUnsigned32 m_active: 1
} |
}; |
void * | m_userData
dgWorld * | m_world
dgCollisionInstance * | m_collision
dgBroadPhase::dgNode * | m_collisionCell
dgBodyMasterList::dgListNode * | m_masterNode
OnBodyDestroy | m_destructor
OnMatrixUpdateCallback | m_matrixUpdate

## Constructor & Destructor Documentation

## § dgKinematicBody() [1/2]

dgKinematicBody::dgKinematicBody | ( |  | ) |

## § dgKinematicBody() [2/2]

dgKinematicBody::dgKinematicBody | ( | dgWorld *const | world,
|  | const dgTree< const dgCollision *, dgInt32 > *const | collisionNode,
|  | dgDeserialize | serializeCallback,
|  | void *const | userData
| ) |  |

## § ~dgKinematicBody()

dgKinematicBody::~dgKinematicBody | ( |  | ) |

virtual

## Member Function Documentation

## § AddDampingAcceleration()

virtual void dgKinematicBody::AddDampingAcceleration | ( |  | ) |

inlinevirtual

Implements dgBody.

## § AddForce()

virtual void dgKinematicBody::AddForce | ( | const dgVector & | force | ) |

inlinevirtual

Implements dgBody.

## § AddTorque()

virtual void dgKinematicBody::AddTorque | ( | const dgVector & | torque | ) |

inlinevirtual

Implements dgBody.

## § ApplyExtenalForces()

virtual void dgKinematicBody::ApplyExtenalForces | ( | dgFloat32 | timestep,
|  | dgInt32 | threadIndex
| ) |  |

inlinevirtual

Implements dgBody.

## § GetAngularDamping()

virtual dgVector dgKinematicBody::GetAngularDamping | ( |  | ) | const

inlinevirtual

Implements dgBody.

## § GetExtForceAndTorqueCallback()

virtual OnApplyExtForceAndTorque dgKinematicBody::GetExtForceAndTorqueCallback | ( |  | ) | const

inlinevirtual

Implements dgBody.

## § GetForce()

virtual const dgVector& dgKinematicBody::GetForce | ( |  | ) | const

inlinevirtual

Implements dgBody.

## § GetLinearDamping()

virtual dgFloat32 dgKinematicBody::GetLinearDamping | ( |  | ) | const

inlinevirtual

Implements dgBody.

## § GetTorque()

virtual const dgVector& dgKinematicBody::GetTorque | ( |  | ) | const

inlinevirtual

Implements dgBody.

## § IsInEquilibrium()

virtual bool dgKinematicBody::IsInEquilibrium | ( |  | ) | const

inlinevirtual

Implements dgBody.

## § PredictAngularVelocity()

virtual dgVector dgKinematicBody::PredictAngularVelocity | ( | dgFloat32 | timestep | ) | const

inlinevirtual

Implements dgBody.

## § PredictLinearVelocity()

virtual dgVector dgKinematicBody::PredictLinearVelocity | ( | dgFloat32 | timestep | ) | const

inlinevirtual

Implements dgBody.

## § Serialize()

void dgKinematicBody::Serialize | ( | const dgTree< dgInt32, const dgCollision *> *const | collisionNode,
|  | dgSerialize | serializeCallback,
|  | void *const | userData
| ) |  |

virtual

Reimplemented from dgBody.

## § SetAngularDamping()

virtual void dgKinematicBody::SetAngularDamping | ( | const dgVector & | angularDamp | ) |

inlinevirtual

Implements dgBody.

## § SetCollidable()

virtual void dgKinematicBody::SetCollidable | ( | bool | state | ) |

inlinevirtual

Implements dgBody.

## § SetExtForceAndTorqueCallback()

virtual void dgKinematicBody::SetExtForceAndTorqueCallback | ( | OnApplyExtForceAndTorque | callback | ) |

inlinevirtual

Implements dgBody.

## § SetForce()

virtual void dgKinematicBody::SetForce | ( | const dgVector & | force | ) |

inlinevirtual

Implements dgBody.

## § SetLinearDamping()

virtual void dgKinematicBody::SetLinearDamping | ( | dgFloat32 | linearDamp | ) |

inlinevirtual

Implements dgBody.

## § SetTorque()

virtual void dgKinematicBody::SetTorque | ( | const dgVector & | torque | ) |

inlinevirtual

Implements dgBody.

## Friends And Related Function Documentation

## § dgBroadPhase

friend class dgBroadPhase

friend

## § dgWorld

friend class dgWorld

friend

## § dgWorldDynamicUpdate

friend class dgWorldDynamicUpdate

friend

## Member Data Documentation

## § m_dummy

dgVector dgKinematicBody::m_dummy

static

The documentation for this class was generated from the following files:

- dynamics.mod/NewtonDynamics/source/physics/dgKinematicBody.h
- dynamics.mod/NewtonDynamics/source/physics/dgKinematicBody.cpp